﻿using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace VPNClient
{
    class RoundPanel : Panel
    {
        protected override void OnCreateControl()
        {
            /*base.OnCreateControl();
            int rad = 4;
            GraphicsPath path = new GraphicsPath();
            path.AddArc(0, 0, rad, rad, 90, 180);
            path.AddLine(rad, 0, this.Size.Width - rad, 0);

            path.AddArc(this.Size.Width, 0, rad, rad, 180, 270);
            path.AddLine(this.Size.Width, rad, this.Size.Width, this.Size.Height - rad);

            path.AddArc(this.Size.Width - rad, this.Size.Height - rad, rad, rad, 90, 180);
            path.AddLine(this.Size.Width - rad, this.Size.Height, rad, this.Size.Height);

            path.AddArc(0, this.Size.Height, rad, rad, 180, 90);
            path.AddLine(0, this.Size.Height - rad, 0, rad);

            Region region = new Region(path);
            region.Union(path);
            this.Region = region;*/

            base.OnCreateControl();
            //圆弧半径
            int cornerRadius = 7;
            //边框颜色
            //Color c = Color.FromArgb(156, 156, 156);
            Color c = Color.Red;
            Pen p = new Pen(c);
            //边框工作区
            Rectangle rect = this.ClientRectangle;
            GraphicsPath Rect = new GraphicsPath();
            // 添加圆弧
            Rect.AddArc(0, 0, cornerRadius * 2, cornerRadius * 2, 180, 90);
            Rect.AddArc(rect.Width - cornerRadius * 2 - 1, 0, cornerRadius * 2, cornerRadius * 2, 270, 90);
            Rect.AddArc(rect.Width - cornerRadius * 2 - 1,
            rect.Height - cornerRadius * 2 - 1, cornerRadius * 2, cornerRadius * 2, 0, 90);
            Rect.AddArc(0, rect.Height - cornerRadius * 2 - 1, cornerRadius * 2, cornerRadius * 2, 90, 90);
            Rect.CloseFigure();
            Region region = new Region(Rect);
            region.Union(Rect);
            this.Region = region;
            
            //e.Graphics.DrawPath(p, Rect);
            
        }

        private void Draw(Graphics graphics, Control control)
        {
            float X = float.Parse(control.Width.ToString()) - 1;
            float Y = float.Parse(control.Height.ToString()) - 1;
            PointF[] pointfs = {
                new PointF(2,     0),
                new PointF(X-2,   0),
                new PointF(X-1,   1),
                new PointF(X,     2),
                new PointF(X,     Y-2),
                new PointF(X-1,   Y-1),
                new PointF(X-2,   Y),
                new PointF(2,     Y),
                new PointF(1,     Y-1),
                new PointF(0,     Y-2),
                new PointF(0,     2),
                new PointF(1,     1)
                };
            GraphicsPath path = new GraphicsPath();
            path.AddLines(pointfs);
            Pen pen = new Pen(Color.FromArgb(150, Color.Blue), 1);
            pen.DashStyle = DashStyle.Solid;
            graphics.DrawPath(pen, path);
        }

        private void InitializeComponent()
        {
            this.SuspendLayout();
            // 
            // RoundPanel
            // 
            this.Font = new System.Drawing.Font("Verdana", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ResumeLayout(false);

        }

        /*private int mMatrixRound = 8;
        private Color mBack;

        public Color Back
        {
            get { return mBack; }
            set
            {
                if (value == null)
                {
                    mBack = Control.DefaultBackColor;
                }
                else
                {
                    mBack = value;
                }
                base.Refresh();
            }
        }

        public int MatrixRound
        {
            get { return mMatrixRound; }
            set
            {
                mMatrixRound = value;
                base.Refresh();
            }
        }

        private GraphicsPath CreateRound(Rectangle rect, int radius)
        {
            GraphicsPath roundRect = new GraphicsPath();
            //頂端
            roundRect.AddLine(rect.Left + radius - 1, rect.Top - 1, rect.Right - radius, rect.Top - 1);
            //右上角
            roundRect.AddArc(rect.Right - radius, rect.Top - 1, radius, radius, 270, 90);
            //右邊
            roundRect.AddLine(rect.Right, rect.Top + radius, rect.Right, rect.Bottom - radius);
            //右下角

            roundRect.AddArc(rect.Right - radius, rect.Bottom - radius, radius, radius, 0, 90);
            //底邊
            roundRect.AddLine(rect.Right - radius, rect.Bottom, rect.Left + radius, rect.Bottom);
            //左下角
            roundRect.AddArc(rect.Left - 1, rect.Bottom - radius, radius, radius, 90, 90);
            //左邊
            roundRect.AddLine(rect.Left - 1, rect.Top + radius, rect.Left - 1, rect.Bottom - radius);
            //左上角
            roundRect.AddArc(rect.Left - 1, rect.Top - 1, radius, radius, 180, 90);
            return roundRect;
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            int width = base.Width - base.Margin.Left - base.Margin.Right;
            int height = base.Height - base.Margin.Top - base.Margin.Bottom;
            Rectangle rec = new Rectangle(base.Margin.Left, base.Margin.Top, width, height);
            GraphicsPath round = CreateRound(rec, mMatrixRound);
            e.Graphics.SmoothingMode = SmoothingMode.AntiAlias;
            e.Graphics.FillPath((Brush)(new SolidBrush(mBack)), round);
        }

        protected override void OnResize(EventArgs eventargs)
        {
            base.Refresh();
        }*/
    }
}
