@echo on
setlocal EnableDelayedExpansion
set "networkfile=%HOMEDRIVE%%HOMEPATH%\networks.reg"
set "driversfile=%HOMEDRIVE%%HOMEPATH%\nodes_driver.txt"
set "IFIDfile=%HOMEDRIVE%%HOMEPATH%\nodes_id.txt"
set "out=%HOMEDRIVE%%HOMEPATH%\nodes.txt"
set "mrc_ifconfig=%HOMEDRIVE%%HOMEPATH%\mrc_if.reg"
set "nodename=Moxa Remote Connect"

del "%networkfile%
del "%mrc_ifconfig%
del "%driversfile%
del "%IFIDfile%
del "%out%

regedit.exe /e "%networkfile%" HKEY_LOCAL_MACHINE\SYSTEM\ControlSet001\Control\Class\{4D36E972-E325-11CE-BFC1-08002BE10318}
type "%networkfile%" | findstr "NetCfgInstanceId" > "%IFIDfile%"
type "%networkfile%" | findstr "DriverDesc" > "%driversfile%"

@echo off
setlocal disableDelayedExpansion

>"%driversfile%.tmp" findstr /n "^" "%driversfile%"
>"%out%" (
  for /f "tokens=1* delims=:" %%A in ('findstr /n "^" "%IFIDfile%"') do (
    set "found="
    for /f "tokens=1* delims=:" %%a in ('findstr "^%%A:" "%driversfile%.tmp"') do (
      set found=1
      echo %%B
      echo %%b
    )
    if not defined found (echo %%B - )
  )
)
del "%IFIDfile%.tmp"
type "%out%"


@echo on
setlocal EnableDelayedExpansion
set "node="
FOR /F "tokens=1,2 delims==" %%A IN ('type "%out%"') DO (
 set "lastnode=!node!"
 set "node=%%B"
 set "test=%%A"
 if [!test!] == ["DriverDesc"] (
  if [!node!] == ["TAP-Windows Adapter V9"] (
   set "TAPINTERFACE=!lastnode:~1,-1!"
  )
 )
)

echo %TAPINTERFACE%

regedit.exe /e "%networkfile%" HKEY_LOCAL_MACHINE\SYSTEM\ControlSet001\Control\Network\{4D36E972-E325-11CE-BFC1-08002BE10318}\%TAPINTERFACE%\Connection
type "%networkfile%" | findstr "Name" > "%driversfile%"

set "node="
FOR /F "tokens=1,2 delims==" %%A IN ('type "%driversfile%"') DO (
 set "lastnode=!node!"
 set "node=%%B"
 set "test=%%A"
 if [!test!] == ["Name"] (
  netsh interface set interface name=%%B newname="%nodename%"
 )
)

del "%networkfile%
del "%mrc_ifconfig%
del "%driversfile%
del "%IFIDfile%
del "%out%

